Index: java/regression/Acme-check-geni.pem
===================================================================
--- java/regression/Acme-check-geni.pem	(revision 1fb793f371838b86e6c55524c1c61e4f6ae931e8)
+++ java/regression/Acme-check-geni.pem	(revision 1fb793f371838b86e6c55524c1c61e4f6ae931e8)
@@ -0,0 +1,26 @@
+-----BEGIN CERTIFICATE-----
+MIIBkTCB+wIGAT6kxEnvMA0GCSqGSIb3DQEBCwUAMA8xDTALBgNVBAMTBEFjbWUw
+HhcNMTMwNTE0MjAzODQ3WhcNMTQwNTE0MjAzODQ3WjAPMQ0wCwYDVQQDEwRBY21l
+MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDGKdLslr1eFYgeO/bp4KAN1A/e
+HjbpY5TWRyRORMPm+cThtbaSrs66KCxHMh8pwJtmy2N6dJ4I3s10PLC4yIL+Z6Ct
+SUlojQi6sQyrkYVO3m9ZLWiTcUfNuSWv+HNX/2V0Ut8F8PwCXNGeHqMvj6bJjdIt
++TOosajuv5PJe3K0EwIDAQABMA0GCSqGSIb3DQEBCwUAA4GBAIKgUhAxK9/u71dI
+WPw67Qi+z3IKIdZPQ8l5QS4LOPri5KsFM2KGlH4Pko/7nwFoBf/4Rs6eqoNSsqRi
+2TR6f/TYppdFZzNsQbyjTGHSf5u6l8iu2oBlZnTiY3WRFnbroHlTkaL2m6YSajfa
+nt00LGjEMpzzsJsHxZjz9eIDF+Qf
+-----END CERTIFICATE-----
+-----BEGIN RSA PRIVATE KEY-----
+MIICXQIBAAKBgQDGKdLslr1eFYgeO/bp4KAN1A/eHjbpY5TWRyRORMPm+cThtbaS
+rs66KCxHMh8pwJtmy2N6dJ4I3s10PLC4yIL+Z6CtSUlojQi6sQyrkYVO3m9ZLWiT
+cUfNuSWv+HNX/2V0Ut8F8PwCXNGeHqMvj6bJjdIt+TOosajuv5PJe3K0EwIDAQAB
+AoGBALJGCCKeTgipWEbS7YRkd7lZEVljV0VKOCk54ViklpViGJRyVKjLqOFiqMr4
+NX7rbyLgUUNmTJJwVud+fgIPKYA+TfJp/iRBQWbuXNCM5zD7fmNxcDNnOJRNwVG2
+X2JGUgyp+5pKXYdqAbY9KWm8XoXpo9pVRBlyleDPLOeAlDxhAkEA7T5RATBYqJvM
+37jiXvKlKZ1tRywtvsE61mWkQRNeGI1VQ3eqVHBRBKg0F+p8lKX43eQ4kMv3v7A5
+lIQxm1kx0QJBANXUjDEH4TSTc0zsZiCaPGFmXtL9SFowENmdwmGaROF0Uyn+NNnB
+cX4xW+TCholl4NxHnMPv1xdOlQG8KKYLPKMCQA7utjCJ93qdW9bVD0KEqUqmQwOQ
+z0xLY0WtXhpOesS22KAHfywTabYOVEERHEhK7hAhVkIe5HgnQmiLrYempJECQQCa
+iIBEkwBDoehrCFGKcE0Ayx3ud5PJcgFLdELdjMMI+Kt9prSFRtMBsyRJP/hA5frK
+14pI5FVbB7SSS2xJC8fnAkBYA6RG5GvPbaawCfog88R2NxRVupeqClcSnRMvlX+T
+fPD1PGZGToe4/b3pdXuHr5b9HzFOWA4IFVdsIHp6xtNI
+-----END RSA PRIVATE KEY-----
Index: java/regression/Acme-check-x509.pem
===================================================================
--- java/regression/Acme-check-x509.pem	(revision 1fb793f371838b86e6c55524c1c61e4f6ae931e8)
+++ java/regression/Acme-check-x509.pem	(revision 1fb793f371838b86e6c55524c1c61e4f6ae931e8)
@@ -0,0 +1,26 @@
+-----BEGIN CERTIFICATE-----
+MIIBkTCB+wIGAT6kwceaMA0GCSqGSIb3DQEBCwUAMA8xDTALBgNVBAMTBEFjbWUw
+HhcNMTMwNTE0MjAzNjAzWhcNMTQwNTE0MjAzNjAzWjAPMQ0wCwYDVQQDEwRBY21l
+MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCtWtbSn5t28qKnHu/aZWS6/AVs
+bew3/20VuW/YZmWWGW0zIi/ditbg0Zcy01O9XH0psI1ZadqpUrXKl0QelqQVfLyi
+j0cSdpJ4T7ohi5iERldW8HPDRim44dOY21WgkhRfzaZa8CRqAMXIK6zYRYApYIZK
+dq52sgrkM9oryD34PQIDAQABMA0GCSqGSIb3DQEBCwUAA4GBABoeWZpmNzQhsGl0
+dT9ViMNrHxYUCD+wQMOiB+aXNtMpoAhpx4Ss3o1rDc+j53cAz+JE+qlKo5Fyq/ta
+BdmntpxaWwtH3V86R5CrPgvBtDo7AgPprW4xY80+MsCmRHh/R6fXZUU70xCA3oBp
+Z1Zb8FdgP68EOj8jTOXbi2S8+FnN
+-----END CERTIFICATE-----
+-----BEGIN RSA PRIVATE KEY-----
+MIICXQIBAAKBgQCtWtbSn5t28qKnHu/aZWS6/AVsbew3/20VuW/YZmWWGW0zIi/d
+itbg0Zcy01O9XH0psI1ZadqpUrXKl0QelqQVfLyij0cSdpJ4T7ohi5iERldW8HPD
+Rim44dOY21WgkhRfzaZa8CRqAMXIK6zYRYApYIZKdq52sgrkM9oryD34PQIDAQAB
+AoGBAJLCs9nuq9RAyDkJ9O+FJYkzsXfBe9lQkk5xBmJDFj/D2PIQQEujrhT4+7NY
+u601rvTrdk87UZZF4ofYFiB7Uf9B9xV7VOZPRmw13dWUmBbA/6xMBiX49mOL71/Q
+E6v60PbuF5Y6PaJhsbqNfpfQbdZ4Lsk75uh8Ms8gO6CyKMThAkEA9fFFJAfBdxop
+44zFw26VRYUQBPoZTUx/IqLFp3P4B+uINIW5hI0okjsWQImDNry7UELsDaR5A6RN
+X/zKpL4vCQJBALRxqV0ngnpaF2muSBUnq88J6C+ggT0usD9Tw3nZ14kw26A9an24
+URvW51o+OwjSd68FeW1HVlWr8hog12k12JUCQF6ZRvbs5MVjEumrpAXf6xqqa9b+
+O+03l09DPLOEL8scFW/eX9VUVl6oy45XVlkfjwz4MMOul72G3Rwmp+tmG8ECQC9u
+bTGScCbPRbY+3K3K5suedA0I6M/3VNbgotKF47UpRaICYtq3N4LU462CDCyOfm1g
+SAHkrZoJf7NEjLsYL10CQQDOTQSZuWxrOyZ16rRJEPHwf7n4hfLdHfrTTd1VxNfl
+KouJuTnKBGsxCAEqsvS5sA8/o9e6fRF4rNDp043BEGuh
+-----END RSA PRIVATE KEY-----
Index: java/regression/e0-check-geni.xml
===================================================================
--- java/regression/e0-check-geni.xml	(revision 1fb793f371838b86e6c55524c1c61e4f6ae931e8)
+++ java/regression/e0-check-geni.xml	(revision 1fb793f371838b86e6c55524c1c61e4f6ae931e8)
@@ -0,0 +1,12 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?><signed-credential><credential xml:id="ref0"><type>abac</type><expires>2014-05-14T20:38:47Z</expires><version>1.0</version><rt0>d9b5e24ea26d35680df74ad0069977488ff3eec2.experiment_create&lt;-d9b5e24ea26d35680df74ad0069977488ff3eec2.partner.experiment_create</rt0></credential><signatures><Signature xmlns="http://www.w3.org/2000/09/xmldsig#"><SignedInfo><CanonicalizationMethod Algorithm="http://www.w3.org/TR/2001/REC-xml-c14n-20010315"/><SignatureMethod Algorithm="http://www.w3.org/2000/09/xmldsig#rsa-sha1"/><Reference URI="#ref0"><Transforms><Transform Algorithm="http://www.w3.org/2000/09/xmldsig#enveloped-signature"/></Transforms><DigestMethod Algorithm="http://www.w3.org/2000/09/xmldsig#sha1"/><DigestValue>m7AYpgI6/XUBnrZ4MlGihS8AFko=</DigestValue></Reference></SignedInfo><SignatureValue>i9Khw3Zs61QCTTi7LFFBcjE+Fu0mr/583xXiBhAVOAOi3wOrYLEiPsuSKcmoAI1QSDVoVJCGOPZo
+/j8wPXex2BXEFtuZuMd9MwCnGffeNcnStLsqNNIRiS81GiCPRN4fL89CV8TDwJAkFGtvOsT3fpxg
+daHyL8Odh/5Eo0b3VhU=</SignatureValue><KeyInfo><KeyValue><RSAKeyValue><Modulus>xinS7Ja9XhWIHjv26eCgDdQP3h426WOU1kckTkTD5vnE4bW2kq7OuigsRzIfKcCbZstjenSeCN7N
+dDywuMiC/megrUlJaI0IurEMq5GFTt5vWS1ok3FHzbklr/hzV/9ldFLfBfD8AlzRnh6jL4+myY3S
+LfkzqLGo7r+TyXtytBM=</Modulus><Exponent>AQAB</Exponent></RSAKeyValue></KeyValue><X509Data><X509SubjectName>CN=Acme</X509SubjectName><X509Certificate>MIIBkTCB+wIGAT6kxEnvMA0GCSqGSIb3DQEBCwUAMA8xDTALBgNVBAMTBEFjbWUwHhcNMTMwNTE0
+MjAzODQ3WhcNMTQwNTE0MjAzODQ3WjAPMQ0wCwYDVQQDEwRBY21lMIGfMA0GCSqGSIb3DQEBAQUA
+A4GNADCBiQKBgQDGKdLslr1eFYgeO/bp4KAN1A/eHjbpY5TWRyRORMPm+cThtbaSrs66KCxHMh8p
+wJtmy2N6dJ4I3s10PLC4yIL+Z6CtSUlojQi6sQyrkYVO3m9ZLWiTcUfNuSWv+HNX/2V0Ut8F8PwC
+XNGeHqMvj6bJjdIt+TOosajuv5PJe3K0EwIDAQABMA0GCSqGSIb3DQEBCwUAA4GBAIKgUhAxK9/u
+71dIWPw67Qi+z3IKIdZPQ8l5QS4LOPri5KsFM2KGlH4Pko/7nwFoBf/4Rs6eqoNSsqRi2TR6f/TY
+ppdFZzNsQbyjTGHSf5u6l8iu2oBlZnTiY3WRFnbroHlTkaL2m6YSajfant00LGjEMpzzsJsHxZjz
+9eIDF+Qf</X509Certificate></X509Data></KeyInfo></Signature></signatures></signed-credential>